; KEYSUM_DELAYROUTINE_407.a51 	Lab mu2: 	 read keypad, add keyval to running sum: DELAY SUBROUTINE  4/02,9/02
;  start address changed to allow use as replacement for earlier delay-inline 4/07

    $NOSYMBOLS		
; default Ride7 path, Mar. 16
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\REG320.INC) 
    $INCLUDE (C:\Program Files\Raisonance\Ride\inc\51\Dallas\vectors320.INC) 	ORG 0		
	SJMP STARTUP		; 	here code begins--with just a jump to start of
							;   real program.  ALL our programs will start thus
							
	ORG 30h				;  ...and here the program starts
							;  Note that this listing overlaps with the previous program.
							;  This is intended, so you'll not need to retype any code 
							;  before the subroutine call, at 42h
	
STARTUP:	MOV DPTR, #8000h	; "point" to both display (OUT0) and keypad (INO)
			MOV SP, #07Fh		; init stack ptr, to just below start of indirect RAM
			MOV R2,#02			; init small delay constant
			MOV R3,#04					

									
			MOV R0, #0			; clear running sum, for predictable start
			MOVX @DPTR, A		; show sum on display: tidy first-pass
			
COUNTUP:	MOVX A, @DPTR		; read the keypad
			ADD A, R0			; form new running sum: new + old, result to A
			NOP
			MOV R0, A			; save result (update running sum)
			MOVX @DPTR, A		; show sum on display.  Now, go kill some time
			ACALL DELAY
			SJMP COUNTUP
			
;---SUBROUTINE 'DELAY'----------

			ORG 100h
DELAY:	PUSH PSW				; save registers that'll get messed up.
			PUSH ACC          ; Not necessary, this time; but next time this
			PUSH B            ;  routine is called, those registers might be 
									;  in use in the main routine, so worth saving
									
			MOV A,R2				; get outer-loop delay value
INITINNER:	MOV B,R3			; initialize inner loop counter
INLOOP:	DJNZ B, INLOOP		; count down inner loop, till inner hits zero
			DJNZ ACC,INITINNER	; ...then dec outer, and start inner again.
			POP B  				; restore saved registers
			POP ACC
			POP PSW
			RET					; Now back to main program.
			 			
			END
			
